package info.bukova.isspst.reporting;

import info.bukova.isspst.data.AuthItem;
import info.bukova.isspst.data.TripBill;
import info.bukova.isspst.data.User;
import info.bukova.isspst.data.UserSettingsData;
import info.bukova.isspst.services.requirement.TripRequirementService;
import info.bukova.isspst.services.users.UserService;
import info.bukova.isspst.storage.FileStorage;

import org.springframework.beans.factory.annotation.Autowired;

public class ParamFiller {
	
	@Autowired
	private ReportDefinition definition;
	@Autowired
	private UserService userService;
	@Autowired
	private FileStorage storage;
	@Autowired
	private TripRequirementService tripReqService;
	
	public void fill() {
		if (definition.getDataSet() == null || definition.getDataSet().isEmpty()) {
			return;
		}
		
		if ((definition.getDataSet().get(0) instanceof TripBill) 
				&& definition.getReport().isSingleRecord()) {
			if (userService.getUserSettings().getSignatureFile() != null 
					&& !userService.getUserSettings().getSignatureFile().isEmpty()) {
				definition.setParam("P_USER_SIGNATURE", storage.serverPath(userService.getUserSettings().getSignatureFile()));
			}
			
			TripBill tb = (TripBill)definition.getDataSet().get(0);
			tripReqService.loadAuthItems(tb.getRequirement());
			AuthItem lastAuth = tb.getRequirement().getAuthorization().get(tb.getRequirement().getAuthorization().size() - 1);
			
			definition.setParam("P_APPROVE_DATE", lastAuth.getAuthDate());
			
			User u = lastAuth.getApprover();
			
			UserSettingsData approverSettings = userService.getUserSettings(u);
			
			if (approverSettings != null 
					&& approverSettings.getSignatureFile() != null 
					&& !approverSettings.getSignatureFile().isEmpty()) {
				definition.setParam("P_APPROVER_SIGNATURE", storage.serverPath(approverSettings.getSignatureFile()));
			}
		}
	}

}
