package info.bukova.isspst.ui.dashboard;

import info.bukova.isspst.data.Role;
import info.bukova.isspst.data.User;
import info.bukova.isspst.data.Workgroup;
import info.bukova.isspst.services.users.UserService;
import info.bukova.isspst.services.workgroups.WorkgroupService;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.zkoss.bind.annotation.Init;
import org.zkoss.zk.ui.select.annotation.WireVariable;

public class DashBoardVM {
	
	@WireVariable
	private WorkgroupService workgroupService;
	@WireVariable
	private UserService userService;
	private User user;
	private Map<Workgroup, List<Role>> groupRoles;
	
	@Init
	public void init() {
		user = userService.getCurrent();
		
		groupRoles = new HashMap<Workgroup, List<Role>>();
		
		List<Workgroup> wg = new ArrayList<Workgroup>();
		if (workgroupService.getUserCentres(user) != null) {
			wg.addAll(workgroupService.getUserCentres(user));
		}
		if (workgroupService.getUserWorkgroups(user) != null) {
			wg.addAll(workgroupService.getUserWorkgroups(user));
		}
		
		for (Workgroup w : wg) {
			List<Role> r = workgroupService.getUserWorkgroupRoles(w, user);
			groupRoles.put(w, r);
		}
	}
	
	public User getUser() {
		return user;
	}
	
	public List<Workgroup> getCentres() {
		return workgroupService.getUserCentres(user);
	}
	
	public List<Workgroup> getWorkgroups() {
		return workgroupService.getUserWorkgroups(user);
	}
	
	public Map<Workgroup, List<Role>> getGroupRoles() {
		return groupRoles;
	}

}
